///////////////////////////////
//                           //
//  http://almazlan.narod.ru //
//  20.05.2005 - 09.08.2005  //
//                           //
///////////////////////////////

#ifndef LEX_ANALYSE_H
#define LEX_ANALYSE_H

enum TokenType
{
    tt_unknown,     //  
    tt_comment,     // 
    tt_quote1,      //    
    tt_quote2,      //    
    tt_name,        // 
    tt_int,         //  
    tt_bin,         //  
    tt_hex,         //  
    tt_real,        //    
    tt_exp,         //       
// 
    tt_exclamation,         // !  
    tt_percent,             // % 
    tt_amper,               // & 
    tt_parenthesis_open,    // (   
    tt_parenthesis_close,   // )   
    tt_asterisk,            // * 
    tt_plus,                // + 
    tt_comma,               // , 
    tt_minus,               // - 
    tt_dot,                 // . 
    tt_slash,               // /  
    tt_colon,               // : 
    tt_semicolon,           // ;   
    tt_less,                // < 
    tt_equal,               // = 
    tt_greater,             // > 
    tt_lid,                 // ^ 
    tt_braces_open,         // {   
    tt_vertical,            // |  
    tt_braces_close,        // }   
    tt_tilde,               // ~ 
//  
    tt_exclamation_equal,   //  !=
    tt_percent_equal,       //  %=
    tt_amper_amper,         //  &&
    tt_amper_equal,         //  &=
    tt_asterisk_equal,      //  *=
    tt_plus_plus,           //  ++
    tt_plus_equal,          //  +=
    tt_minus_minus,         //  --
    tt_minus_equal,         //  -=
    tt_minus_greater,       //  ->
    tt_slash_equal,         //  /=
    tt_less_less,           //  <<
    tt_less_less_equal,     // <<=
    tt_less_equal,          //  <=
    tt_equal_equal,         //  ==
    tt_greater_greater,     //  >>
    tt_greater_equal,       //  >=
    tt_greater_greater_equal,// >>=
    tt_lid_equal,           //  ^=
    tt_vertical_equal,      //  |=
    tt_vertical_vertical,   //  ||
//  
// 2
    tt_if,
    tt_for,
// 4
    tt_else,
    tt_int8,
// 5
    tt_break,
    tt_int16,
    tt_int32,
    tt_int64,
    tt_uint8,
    tt_while,
// 6
    tt_real32,
    tt_real64,
    tt_return,
    tt_uint16,
    tt_uint32,
    tt_uint64,
// 7
// 8
    tt_continue,
};

enum LexReturn
{
    lr_ok,
    lr_bad_bin,
    lr_bad_hex,
    lr_bad_num,
    lr_no_quote1,
    lr_no_quote2,
    lr_open_comment,
    lr_unknown_character,
};

struct Token
{
    TokenType type;
    const unsigned char * text;
    int size;
};

#include <vector>

//  
LexReturn lex_analyse ( int size, const unsigned char * source, std::vector<Token> & result );

//     
void keywords ( std::vector<Token> & result );

#endif