///////////////////////////////
//                           //
//  http://almazlan.narod.ru //
//  20.05.2005 - 09.08.2005  //
//                           //
///////////////////////////////

#include "Translate.h"
#include "lex_analyse.h"

TranReturn translate ( int size, const unsigned char * source, std::vector<unsigned char> & result ) 
{
    std::vector<Token> vtoken; //   
//  
    LexReturn lr = lex_analyse ( size, source, vtoken );
//     
    keywords ( vtoken );
//    
    for ( int i = 0; i < vtoken.size(); ++i )
    {
        const Token & token = vtoken[i];
        int n = token.size;
        const unsigned char * p = token.text;
        switch ( token.type )
        {
        case tt_int:
            {
                while ( n > 1 && *p == '0' )
                {
                    ++p;
                    --n;
                    result.push_back ( ' ' );
                }
                break;
            }
        case tt_int8: 
        case tt_int16: 
        case tt_int32: 
        case tt_int64: 
            result.push_back ( '_' );
            result.push_back ( '_' );
            break;
        case tt_uint8: 
            {
                p = (const unsigned char *) "unsigned __int8";
                n = 15;
                break;
            }
        case tt_uint16: 
            {
                p = (const unsigned char *) "unsigned __int16";
                n = 16;
                break;
            }
        case tt_uint32: 
            {
                p = (const unsigned char *) "unsigned __int32";
                n = 16;
                break;
            }
        case tt_uint64: 
            {
                p = (const unsigned char *) "unsigned __int64";
                n = 16;
                break;
            }
        case tt_real32:
            {
                p = (const unsigned char *) "float";
                n = 5;
                break;
            }
        case tt_real64:
            {
                p = (const unsigned char *) "double";
                n = 6;
                break;
            }
        }
        for ( int j = 0; j < n; ++j )
        {
            result.push_back ( p[j] );
        }
    }
    switch ( lr )
    {
    case lr_bad_bin:
        {
            return tr_bad_bin;
        }
    case lr_bad_hex:
        {
            return tr_bad_hex;
        }
    case lr_bad_num:
        {
            return tr_bad_num;
        }
    case lr_no_quote1:
        {
            return tr_no_quote1;
        }
    case lr_no_quote2:
        {
            return tr_no_quote2;
        }
    case lr_open_comment:
        {
            return tr_open_comment;
        }
    case lr_unknown_character:
        {
            return tr_unknown_character;
        }
    }
    return tr_ok;
}