// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Translator.h"

#include "MainFrm.h"

#include "TranslatorDoc.h"
#include "TranslatorView.h"

#include "core\Translate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_A_TO_CPP, OnAToCpp)
	ON_COMMAND(ID_PROJECT_SAVE_CPP_CODE, OnSaveCPPCode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{


	InitDefauldFont();//  


    if ( ! m_wndSplitter.CreateStatic ( this, 1, 2 ) )
    {
        TRACE("Failed to CreateStaticSplitter");
        return(FALSE);
    }
	
    CRect rectClient;
    GetClientRect ( rectClient );
    CSize size = rectClient.Size();
    size.cx /= 2;
    size.cy /= 2;

    m_wndSplitter.CreateView (
		                      0, 
							  0, 
							  RUNTIME_CLASS( CTranslatorView ),
							  size, 
							  pContext );

    m_wndSplitter.CreateView ( 
		                      0, 
							  1, 
							  RUNTIME_CLASS( CRichEditView /* RichView  */ ), 
							  size, 
							  pContext 
							  );

	CTranslatorView *pLftView = ( CTranslatorView * )m_wndSplitter.GetPane(0, 0);
	(pLftView->GetEditCtrl()).SetFont( &m_fnFont, true);// .

	int sMin, sMax;

	pLftView->GetScrollRange(SB_VERT, &sMin, &sMax);

	CRichEditView *pRighView = ( CRichEditView * )m_wndSplitter.GetPane(0, 1);
	( pRighView->GetRichEditCtrl() ).SendMessage( EM_SETREADONLY, TRUE, NULL );//    .	
	( pRighView->GetRichEditCtrl() ).SendMessage(EM_SETTARGETDEVICE, 0, 0);    //   
	( pRighView->GetRichEditCtrl() ).SendMessage(EM_SETTARGETDEVICE, 0, 1);    //   
	pRighView->SetScrollRange(sMin, sMax,TRUE);
    
	return TRUE;
}
//***********************************************************************
//****                      CPP                     ****    
//***********************************************************************
void CMainFrame::OnAToCpp() 
{
	CString source;
	CString csGetText;
	CRichEditView *pView = ( CRichEditView * )m_wndSplitter.GetPane(0, 1);
	
	
	

	m_wndSplitter.GetPane(0, 0)->GetWindowText( source );

    std::vector<unsigned char> vres;
    TranReturn tr = translate (  source.GetLength(), (const unsigned char *)(LPCTSTR)source, vres );
    vres.push_back ( 0 );
	CString result ( &vres[0] );
    switch ( tr )
    {
    case tr_bad_bin:
        {
            result += "  ";
            break;
        }
    case tr_bad_hex:
        {
            result += "  ";
            break;
        }
    case tr_bad_num:
        {
            result += "  ";
            break;
        }
    case tr_no_quote1:
        {
            result += "'   ";
            break;
        }
    case tr_no_quote2:
        {
            result += "\"   ";
            break;
        }
    case tr_open_comment:
        {
            result += "/*  ";
            break;
        }
    case tr_unknown_character:
        {
            result += "c c";
            break;
        }
    }
    m_wndSplitter.GetPane(0, 1)->SetWindowText(result);

//***********************************************************************
//****                                            ****    
//***********************************************************************
	long mask = ( pView->GetRichEditCtrl() ).GetEventMask();

	( pView->GetRichEditCtrl() ).SetEventMask(mask |= ENM_CHANGE );
	( pView->GetRichEditCtrl() ).SetRedraw(FALSE);

	sc.Colorize( 0, -1, &( pView->GetRichEditCtrl() ) );

	( pView->GetRichEditCtrl() ).SetSel(0,0);
	( pView->GetRichEditCtrl() ).SetRedraw(TRUE);
	( pView->GetRichEditCtrl() ).RedrawWindow();
	//( pView->GetRichEditCtrl() ).SendMessage( EM_SETREADONLY, TRUE, NULL ); //   .


//************************************************************************


}
//************************************************************************
//****                *.cpp            ****
//************************************************************************

void CMainFrame::OnSaveCPPCode() 
{

	CString csGetText;
	HANDLE hNewFile;
	DWORD dwBytesWritten = 0; 

	CFileDialog dlg( FALSE );
	CString str, path;

	str = "  *.cpp";
	str += ( TCHAR )NULL;
	str += "*.cpp";
	str += ( TCHAR )NULL;
	str += "  *.*";
	str += ( TCHAR )NULL;
	str += "*.*";
	str += ( TCHAR )NULL;

	dlg.m_ofn.lpstrFilter = str;
	dlg.m_ofn.nFilterIndex= 0;
	
	if (dlg.DoModal() == IDOK)
	{
		

		path = dlg.GetPathName();  
        if ( path.Find( ".cpp" ) == -1 )
		{
			path.Insert( path.GetLength(), ".cpp" );
		}

		
   	    m_wndSplitter.GetPane( 0, 1 )->GetWindowText( csGetText );

		if (strlen(csGetText) != 0)
		{

		
			hNewFile = CreateFile(
			                  __TEXT( path ) ,
							  GENERIC_READ | GENERIC_WRITE, 
							  0,
							  NULL, 
							  CREATE_ALWAYS,
							  FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, 
							  NULL
			
							  ); 
			WriteFile( 
			      hNewFile, 
				  csGetText, 
				  csGetText.GetLength(), 
				  &dwBytesWritten, 
				  NULL 
			      );
			CloseHandle( hNewFile );
		}
		else
		{
			MessageBox(" .",NULL, MB_OK);
		}
	}


}
//************************************************************************
//****                         ****
//************************************************************************
void CMainFrame::InitDefauldFont() 
{
   
   m_LogFont.lfHeight           = -13; 
   m_LogFont.lfWidth            = 0;
   m_LogFont.lfEscapement       = 0;
   m_LogFont.lfOrientation      = 0;
   m_LogFont.lfWeight           = FW_NORMAL;
   m_LogFont.lfItalic           = 0;
   m_LogFont.lfUnderline        = 0;
   m_LogFont.lfStrikeOut        = 0;
   m_LogFont.lfCharSet          = RUSSIAN_CHARSET;
   m_LogFont.lfOutPrecision     = OUT_STRING_PRECIS;
   m_LogFont.lfClipPrecision    = CLIP_STROKE_PRECIS;
   m_LogFont.lfQuality          = DEFAULT_QUALITY;
   m_LogFont.lfPitchAndFamily   = FIXED_PITCH | FF_MODERN; 
   _tcscpy(m_LogFont.lfFaceName, _T("Courier New"));
   m_fnFont.CreateFontIndirect(&m_LogFont); 

}

void CMainFrame::SetPosSCroll(int nPos)
{

	UpdateData(TRUE);
	CRichEditView *pView = ( CRichEditView * )m_wndSplitter.GetPane(0, 1);
	//(s->GetEditCtrl()).SetScrollPos

	 //pView->GetRichEditCtrl().SendMessage(WM_VSCROLL, 3, NULL); //SetScrollPos(SB_VERT,nPos*20);


	pView->SetScrollPos(SB_VERT,nPos*20);
	//pView->ScrollWindow(0, nPos*20, NULL, NULL);
	//pView->UpdateWindow();
	//pView->SendMessage(WM_VSCROLL, nPos, NULL);
	//pView->LineScroll(iline_count, ichar_count);

	//CString msg;
	//msg.Format("%d",nPos); 
	//MessageBox(msg, NULL,MB_OK);

}